]> git.notmuchmail.org Git - notmuch/blobdiff - test/test-lib.sh
test: add notmuch_show_sanitize_all function that is a little more aggressive.
[notmuch] / test / test-lib.sh
old mode 100644 (file)
new mode 100755 (executable)
index d5d61e4..078f060
@@ -1,4 +1,4 @@
-#!/bin/bash
+#!/usr/bin/env bash
 #
 # Copyright (c) 2005 Junio C Hamano
 #
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see http://www.gnu.org/licenses/ .
 
+if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
+    echo "Error: The notmuch test suite requires a bash version >= 4.0"
+    echo "due to use of associative arrays within the test suite."
+    echo "Please try again with a newer bash (or help us fix the"
+    echo "test suite to be more portable). Thanks."
+    exit 1
+fi
+
 # if --tee was passed, write the output not only to the terminal, but
 # additionally to the file test-results/$BASENAME.out, too.
 case "$GIT_TEST_TEE_STARTED, $* " in
@@ -136,7 +144,7 @@ else
 fi
 
 error () {
-       say_color error "error: $*"
+       say_color error "error: $*\n"
        GIT_EXIT_OK=t
        exit 1
 }
@@ -154,15 +162,9 @@ then
        exit 0
 fi
 
-echo "Testing ${test_description}"
+echo $(basename "$0"): "Testing ${test_description}"
 
 exec 5>&1
-if test "$verbose" = "t"
-then
-       exec 4>&2 3>&1
-else
-       exec 4>/dev/null 3>/dev/null
-fi
 
 test_failure=0
 test_count=0
@@ -237,6 +239,12 @@ increment_mtime ()
 #      Generate the message in directory 'directory/of/choice' within
 #      the mail store. The directory will be created if necessary.
 #
+#  [filename]=name
+#
+#      Store the message in file 'name'. The default is to store it
+#      in 'msg-<count>', where <count> is three-digit number of the
+#      message.
+#      
 #  [body]=text
 #
 #      Text to use as the body of the email message
@@ -273,10 +281,14 @@ generate_message ()
     local additional_headers
 
     gen_msg_cnt=$((gen_msg_cnt + 1))
-    gen_msg_name=msg-$(printf "%03d" $gen_msg_cnt)
+    if [ -z "${template[filename]}" ]; then
+       gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
+    else
+       gen_msg_name=${template[filename]}
+    fi
 
     if [ -z "${template[id]}" ]; then
-       gen_msg_id="${gen_msg_name}@notmuch-test-suite"
+       gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
     else
        gen_msg_id="${template[id]}"
     fi
@@ -339,8 +351,11 @@ ${additional_headers}"
 ${additional_headers}"
     fi
 
+    # Note that in the way we're setting it above and using it below,
+    # `additional_headers' will also serve as the header / body separator
+    # (empty line in between).
 
-cat <<EOF >"$gen_msg_filename"
+    cat <<EOF >"$gen_msg_filename"
 From: ${template[from]}
 To: ${template[to]}
 Message-Id: <${gen_msg_id}>
@@ -354,7 +369,7 @@ EOF
     increment_mtime "$(dirname "${gen_msg_filename}")"
 }
 
-# Generate a new message and add it to the index.
+# Generate a new message and add it to the database.
 #
 # All of the arguments and return values supported by generate_message
 # are also supported here, so see that function for details.
@@ -364,9 +379,37 @@ add_message ()
     notmuch new > /dev/null
 }
 
+# Generate a corpus of email and add it to the database.
+#
+# This corpus is fixed, (it happens to be 50 messages from early in
+# the history of the notmuch mailing list), which allows for reliably
+# testing commands that need to operate on a not-totally-trivial
+# number of messages.
+add_email_corpus ()
+{
+    rm -rf ${MAIL_DIR}
+    if [ -d ../corpus.mail ]; then
+       cp -a ../corpus.mail ${MAIL_DIR}
+    else
+       cp -a ../corpus ${MAIL_DIR}
+       notmuch new >/dev/null
+       cp -a ${MAIL_DIR} ../corpus.mail
+    fi
+}
+
 test_begin_subtest ()
 {
+    if [ -n "$inside_subtest" ]; then
+       exec 1>&6 2>&7          # Restore stdout and stderr
+       error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
+    fi
     test_subtest_name="$1"
+    # Remember stdout and stderr file descriptios and redirect test
+    # output to the previously prepared file descriptors 3 and 4 (see
+    # below)
+    if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
+    exec 6>&1 7>&2 >&3 2>&4
+    inside_subtest=t
 }
 
 # Pass test if two arguments match
@@ -377,6 +420,8 @@ test_begin_subtest ()
 # name.
 test_expect_equal ()
 {
+       exec 1>&6 2>&7          # Restore stdout and stderr
+       inside_subtest=
        test "$#" = 3 && { prereq=$1; shift; } || prereq=
        test "$#" = 2 ||
        error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
@@ -385,7 +430,6 @@ test_expect_equal ()
        expected="$2"
        if ! test_skip "$@"
        then
-               say >&3 "expecting success: diff $output $expected"
                if [ "$output" = "$expected" ]; then
                        test_ok_ "$test_subtest_name"
                else
@@ -394,14 +438,54 @@ test_expect_equal ()
                        echo "$output" > $testname.output
                        test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
                fi
-               echo >&3 ""
     fi
 }
 
-TEST_DIR=$(pwd)/test.$$
-MAIL_DIR=${TEST_DIR}/mail
-export NOTMUCH_CONFIG=${TEST_DIR}/notmuch-config
-NOTMUCH=notmuch
+test_expect_equal_file ()
+{
+       exec 1>&6 2>&7          # Restore stdout and stderr
+       inside_subtest=
+       test "$#" = 3 && { prereq=$1; shift; } || prereq=
+       test "$#" = 2 ||
+       error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
+
+       output="$1"
+       expected="$2"
+       if ! test_skip "$@"
+       then
+               if diff -q "$expected" "$output" >/dev/null ; then
+                       test_ok_ "$test_subtest_name"
+               else
+                       testname=$this_test.$test_count
+                       mv "$output" $testname.output
+                       mv "$expected" $testname.expected
+                       test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
+               fi
+    fi
+}
+
+test_expect_equal_failure ()
+{
+       exec 1>&6 2>&7          # Restore stdout and stderr
+       inside_subtest=
+       test "$#" = 3 && { prereq=$1; shift; } || prereq=
+       test "$#" = 2 ||
+       error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
+
+       output="$1"
+       expected="$2"
+       if ! test_skip "$@"
+       then
+               if [ "$output" = "$expected" ]; then
+                       test_known_broken_ok_ "$test_subtest_name"
+               else
+                       test_known_broken_failure_ "$test_subtest_name"
+                       testname=$this_test.$test_count
+                       echo "$expected" > $testname.expected
+                       echo "$output" > $testname.output
+               fi
+    fi
+}
 
 NOTMUCH_NEW ()
 {
@@ -418,6 +502,12 @@ notmuch_show_sanitize ()
 {
     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
 }
+notmuch_show_sanitize_all ()
+{
+    sed \
+       -e 's| filename:.*| filename:XXXXX|' \
+       -e 's| id:[^ ]* | id:XXXXX |'
+}
 
 # End of notmuch helper functions
 
@@ -461,6 +551,7 @@ test_failure_ () {
        echo " $1"
        shift
        echo "$@" | sed -e 's/^/        /'
+       if test "$verbose" != "t"; then cat test.output; fi
        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 }
 
@@ -482,6 +573,7 @@ test_debug () {
 
 test_run_ () {
        test_cleanup=:
+       if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
        eval >&3 2>&4 "$1"
        eval_ret=$?
        eval >&3 2>&4 "$test_cleanup"
@@ -522,7 +614,6 @@ test_expect_failure () {
        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
        if ! test_skip "$@"
        then
-               say >&3 "checking known breakage: $2"
                test_run_ "$2"
                if [ "$?" = 0 -a "$eval_ret" = 0 ]
                then
@@ -531,7 +622,6 @@ test_expect_failure () {
                        test_known_broken_failure_ "$1"
                fi
        fi
-       echo >&3 ""
 }
 
 test_expect_success () {
@@ -540,7 +630,6 @@ test_expect_success () {
        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
        if ! test_skip "$@"
        then
-               say >&3 "expecting success: $2"
                test_run_ "$2"
                if [ "$?" = 0 -a "$eval_ret" = 0 ]
                then
@@ -549,7 +638,6 @@ test_expect_success () {
                        test_failure_ "$@"
                fi
        fi
-       echo >&3 ""
 }
 
 test_expect_code () {
@@ -558,7 +646,6 @@ test_expect_code () {
        error "bug in the test script: not 3 or 4 parameters to test-expect-code"
        if ! test_skip "$@"
        then
-               say >&3 "expecting exit code $1: $3"
                test_run_ "$3"
                if [ "$?" = 0 -a "$eval_ret" = "$1" ]
                then
@@ -567,7 +654,6 @@ test_expect_code () {
                        test_failure_ "$@"
                fi
        fi
-       echo >&3 ""
 }
 
 # test_external runs external test scripts that provide continuous
@@ -613,7 +699,6 @@ test_external_without_stderr () {
        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
        descr="no stderr: $1"
        shift
-       say >&3 "expecting no stderr from previous command"
        if [ ! -s "$stderr" ]; then
                rm "$stderr"
                test_ok_ "$descr"
@@ -704,13 +789,62 @@ test_done () {
        echo
 
        if [ "$test_failure" = "0" ]; then
-           rm -rf "$remove_tmp"
+           if [ "$test_broken" = "0" ]; then       
+               rm -rf "$remove_tmp"
+           fi
            exit 0
        else
            exit 1
        fi
 }
 
+test_emacs () {
+       # Construct a little test script here for the benefit of the user,
+       # (who can easily run "run_emacs" to get the same emacs environment
+       # for investigating any failures).    
+       cat <<EOF > run_emacs
+#!/bin/sh
+export PATH=$PATH
+export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
+
+# We assume that the user will give a command-line argument only if
+# wanting to run in batch mode.
+if [ \$# -gt 0 ]; then
+       BATCH=--batch
+fi
+
+# Here's what we are using here:
+#
+# --batch:             Quit after given commands and print all (messages)
+#
+# --no-init-file       Don't load users ~/.emacs
+#
+# --no-site-file       Don't load the site-wide startup stuff
+#
+# --directory          Ensure that the local elisp sources are found
+#
+# --load               Force loading of notmuch.el and test-lib.el
+#
+# notmuch-test-wait    Function for tests to use to wait for process completion
+#
+# message-signature    Avoiding appending user's signature on messages
+#
+# set-frame-width      80 columns (avoids crazy 10-column default of --batch)
+
+emacs \$BATCH --no-init-file --no-site-file \
+       --directory ../../emacs --load notmuch.el \
+       --directory .. --load test-lib.el \
+       --eval "(defun notmuch-test-wait ()
+                       (while (get-buffer-process (current-buffer))
+                               (sleep-for 0.1)))" \
+       --eval "(setq message-signature nil)" \
+       --eval "(progn (set-frame-width (window-frame (get-buffer-window)) 80) \$@)"
+EOF
+       chmod a+x ./run_emacs
+       ./run_emacs "$@"
+}
+
+
 find_notmuch_path ()
 {
     dir="$1"
@@ -815,7 +949,7 @@ MAIL_DIR="${TMP_DIRECTORY}/mail"
 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
 
 mkdir -p "${test}"
-mkdir "$MAIL_DIR"
+mkdir -p "${MAIL_DIR}"
 
 cat <<EOF >"${NOTMUCH_CONFIG}"
 [database]
@@ -832,8 +966,14 @@ EOF
 # in subprocesses like git equals our $PWD (for pathname comparisons).
 cd -P "$test" || error "Cannot setup test environment"
 
+if test "$verbose" = "t"
+then
+       exec 4>&2 3>&1
+else
+       exec 4>test.output 3>&4
+fi
+
 this_test=${0##*/}
-this_test=${this_test%%-*}
 for skp in $NOTMUCH_SKIP_TESTS
 do
        to_skip=